import A, { createContext as Oe, memo as bn, useReducer as st, useState as Y, useRef as z, useMemo as L, useCallback as U, useEffect as N, useContext as ae, cloneElement as yn, forwardRef as mn } from "react";
import { unstable_batchedUpdates as De, createPortal as wn } from "react-dom";
import { getWindow as J, useLatestValue as Re, useUniqueId as Ye, getEventCoordinates as Fe, add as he, useIsomorphicLayoutEffect as re, useInterval as Dn, usePrevious as $e, useLazyMemo as Ae, subtract as Ke, canUseDOM as at, isHTMLElement as Ue, useNodeRef as Xe, isKeyboardEvent as lt, findFirstFocusableNode as xn, CSS as nt, useEvent as ct, isWindow as ut, isNode as Cn, isDocument as Wt, getOwnerDocument as ge, isSVGElement as Sn } from "../../utilities/dist/utilities.esm.mjs";
import { useAnnouncement as Rn, HiddenText as En, LiveRegion as On } from "../../accessibility/dist/accessibility.esm.mjs";
const Yt = /* @__PURE__ */ Oe(null);
function An(e) {
  const t = ae(Yt);
  N(() => {
    if (!t)
      throw new Error("useDndMonitor must be used within a children of <DndContext>");
    return t(e);
  }, [e, t]);
}
function Nn() {
  const [e] = Y(() => /* @__PURE__ */ new Set()), t = U((r) => (e.add(r), () => e.delete(r)), [e]);
  return [U((r) => {
    let {
      type: i,
      event: o
    } = r;
    e.forEach((s) => {
      var a;
      return (a = s[i]) == null ? void 0 : a.call(s, o);
    });
  }, [e]), t];
}
const Mn = {
  draggable: `
    To pick up a draggable item, press the space bar.
    While dragging, use the arrow keys to move the item.
    Press space again to drop the item in its new position, or press escape to cancel.
  `
}, Tn = {
  onDragStart(e) {
    let {
      active: t
    } = e;
    return "Picked up draggable item " + t.id + ".";
  },
  onDragOver(e) {
    let {
      active: t,
      over: n
    } = e;
    return n ? "Draggable item " + t.id + " was moved over droppable area " + n.id + "." : "Draggable item " + t.id + " is no longer over a droppable area.";
  },
  onDragEnd(e) {
    let {
      active: t,
      over: n
    } = e;
    return n ? "Draggable item " + t.id + " was dropped over droppable area " + n.id : "Draggable item " + t.id + " was dropped.";
  },
  onDragCancel(e) {
    let {
      active: t
    } = e;
    return "Dragging was cancelled. Draggable item " + t.id + " was dropped.";
  }
};
function Ln(e) {
  let {
    announcements: t = Tn,
    container: n,
    hiddenTextDescribedById: r,
    screenReaderInstructions: i = Mn
  } = e;
  const {
    announce: o,
    announcement: s
  } = Rn(), a = Ye("DndLiveRegion"), [l, c] = Y(!1);
  if (N(() => {
    c(!0);
  }, []), An(L(() => ({
    onDragStart(u) {
      let {
        active: g
      } = u;
      o(t.onDragStart({
        active: g
      }));
    },
    onDragMove(u) {
      let {
        active: g,
        over: f
      } = u;
      t.onDragMove && o(t.onDragMove({
        active: g,
        over: f
      }));
    },
    onDragOver(u) {
      let {
        active: g,
        over: f
      } = u;
      o(t.onDragOver({
        active: g,
        over: f
      }));
    },
    onDragEnd(u) {
      let {
        active: g,
        over: f
      } = u;
      o(t.onDragEnd({
        active: g,
        over: f
      }));
    },
    onDragCancel(u) {
      let {
        active: g,
        over: f
      } = u;
      o(t.onDragCancel({
        active: g,
        over: f
      }));
    }
  }), [o, t])), !l)
    return null;
  const d = A.createElement(A.Fragment, null, A.createElement(En, {
    id: r,
    value: i.draggable
  }), A.createElement(On, {
    id: a,
    announcement: s
  }));
  return n ? wn(d, n) : d;
}
var O;
(function(e) {
  e.DragStart = "dragStart", e.DragMove = "dragMove", e.DragEnd = "dragEnd", e.DragCancel = "dragCancel", e.DragOver = "dragOver", e.RegisterDroppable = "registerDroppable", e.SetDroppableDisabled = "setDroppableDisabled", e.UnregisterDroppable = "unregisterDroppable";
})(O || (O = {}));
function je() {
}
const _ = /* @__PURE__ */ Object.freeze({
  x: 0,
  y: 0
});
function kn(e, t) {
  const n = Fe(e);
  if (!n)
    return "0 0";
  const r = {
    x: (n.x - t.left) / t.width * 100,
    y: (n.y - t.top) / t.height * 100
  };
  return r.x + "% " + r.y + "%";
}
function In(e, t) {
  let {
    data: {
      value: n
    }
  } = e, {
    data: {
      value: r
    }
  } = t;
  return r - n;
}
function zn(e, t) {
  if (!e || e.length === 0)
    return null;
  const [n] = e;
  return t ? n[t] : n;
}
function Pn(e, t) {
  const n = Math.max(t.top, e.top), r = Math.max(t.left, e.left), i = Math.min(t.left + t.width, e.left + e.width), o = Math.min(t.top + t.height, e.top + e.height), s = i - r, a = o - n;
  if (r < i && n < o) {
    const l = t.width * t.height, c = e.width * e.height, d = s * a, u = d / (l + c - d);
    return Number(u.toFixed(4));
  }
  return 0;
}
const Bn = (e) => {
  let {
    collisionRect: t,
    droppableRects: n,
    droppableContainers: r
  } = e;
  const i = [];
  for (const o of r) {
    const {
      id: s
    } = o, a = n.get(s);
    if (a) {
      const l = Pn(a, t);
      l > 0 && i.push({
        id: s,
        data: {
          droppableContainer: o,
          value: l
        }
      });
    }
  }
  return i.sort(In);
};
function Fn(e, t, n) {
  return {
    ...e,
    scaleX: t && n ? t.width / n.width : 1,
    scaleY: t && n ? t.height / n.height : 1
  };
}
function Ut(e, t) {
  return e && t ? {
    x: e.left - t.left,
    y: e.top - t.top
  } : _;
}
function $n(e) {
  return function(n) {
    for (var r = arguments.length, i = new Array(r > 1 ? r - 1 : 0), o = 1; o < r; o++)
      i[o - 1] = arguments[o];
    return i.reduce((s, a) => ({
      ...s,
      top: s.top + e * a.y,
      bottom: s.bottom + e * a.y,
      left: s.left + e * a.x,
      right: s.right + e * a.x
    }), {
      ...n
    });
  };
}
const Kn = /* @__PURE__ */ $n(1);
function _t(e) {
  if (e.startsWith("matrix3d(")) {
    const t = e.slice(9, -1).split(/, /);
    return {
      x: +t[12],
      y: +t[13],
      scaleX: +t[0],
      scaleY: +t[5]
    };
  } else if (e.startsWith("matrix(")) {
    const t = e.slice(7, -1).split(/, /);
    return {
      x: +t[4],
      y: +t[5],
      scaleX: +t[0],
      scaleY: +t[3]
    };
  }
  return null;
}
function Xn(e, t, n) {
  const r = _t(t);
  if (!r)
    return e;
  const {
    scaleX: i,
    scaleY: o,
    x: s,
    y: a
  } = r, l = e.left - s - (1 - i) * parseFloat(n), c = e.top - a - (1 - o) * parseFloat(n.slice(n.indexOf(" ") + 1)), d = i ? e.width / i : e.width, u = o ? e.height / o : e.height;
  return {
    width: d,
    height: u,
    top: c,
    right: l + d,
    bottom: c + u,
    left: l
  };
}
const jn = {
  ignoreTransform: !1
};
function Ne(e, t) {
  t === void 0 && (t = jn);
  let n = e.getBoundingClientRect();
  if (t.ignoreTransform) {
    const {
      transform: c,
      transformOrigin: d
    } = J(e).getComputedStyle(e);
    c && (n = Xn(n, c, d));
  }
  const {
    top: r,
    left: i,
    width: o,
    height: s,
    bottom: a,
    right: l
  } = n;
  return {
    top: r,
    left: i,
    width: o,
    height: s,
    bottom: a,
    right: l
  };
}
function kt(e) {
  return Ne(e, {
    ignoreTransform: !0
  });
}
function Wn(e) {
  const t = e.innerWidth, n = e.innerHeight;
  return {
    top: 0,
    left: 0,
    right: t,
    bottom: n,
    width: t,
    height: n
  };
}
function Yn(e, t) {
  return t === void 0 && (t = J(e).getComputedStyle(e)), t.position === "fixed";
}
function Un(e, t) {
  t === void 0 && (t = J(e).getComputedStyle(e));
  const n = /(auto|scroll|overlay)/;
  return ["overflow", "overflowX", "overflowY"].some((i) => {
    const o = t[i];
    return typeof o == "string" ? n.test(o) : !1;
  });
}
function dt(e, t) {
  const n = [];
  function r(i) {
    if (t != null && n.length >= t || !i)
      return n;
    if (Wt(i) && i.scrollingElement != null && !n.includes(i.scrollingElement))
      return n.push(i.scrollingElement), n;
    if (!Ue(i) || Sn(i) || n.includes(i))
      return n;
    const o = J(e).getComputedStyle(i);
    return i !== e && Un(i, o) && n.push(i), Yn(i, o) ? n : r(i.parentNode);
  }
  return e ? r(e) : n;
}
function Ht(e) {
  const [t] = dt(e, 1);
  return t ?? null;
}
function Qe(e) {
  return !at || !e ? null : ut(e) ? e : Cn(e) ? Wt(e) || e === ge(e).scrollingElement ? window : Ue(e) ? e : null : null;
}
function Jt(e) {
  return ut(e) ? e.scrollX : e.scrollLeft;
}
function qt(e) {
  return ut(e) ? e.scrollY : e.scrollTop;
}
function rt(e) {
  return {
    x: Jt(e),
    y: qt(e)
  };
}
var T;
(function(e) {
  e[e.Forward = 1] = "Forward", e[e.Backward = -1] = "Backward";
})(T || (T = {}));
function Vt(e) {
  return !at || !e ? !1 : e === document.scrollingElement;
}
function Gt(e) {
  const t = {
    x: 0,
    y: 0
  }, n = Vt(e) ? {
    height: window.innerHeight,
    width: window.innerWidth
  } : {
    height: e.clientHeight,
    width: e.clientWidth
  }, r = {
    x: e.scrollWidth - n.width,
    y: e.scrollHeight - n.height
  }, i = e.scrollTop <= t.y, o = e.scrollLeft <= t.x, s = e.scrollTop >= r.y, a = e.scrollLeft >= r.x;
  return {
    isTop: i,
    isLeft: o,
    isBottom: s,
    isRight: a,
    maxScroll: r,
    minScroll: t
  };
}
const _n = {
  x: 0.2,
  y: 0.2
};
function Hn(e, t, n, r, i) {
  let {
    top: o,
    left: s,
    right: a,
    bottom: l
  } = n;
  r === void 0 && (r = 10), i === void 0 && (i = _n);
  const {
    isTop: c,
    isBottom: d,
    isLeft: u,
    isRight: g
  } = Gt(e), f = {
    x: 0,
    y: 0
  }, D = {
    x: 0,
    y: 0
  }, h = {
    height: t.height * i.y,
    width: t.width * i.x
  };
  return !c && o <= t.top + h.height ? (f.y = T.Backward, D.y = r * Math.abs((t.top + h.height - o) / h.height)) : !d && l >= t.bottom - h.height && (f.y = T.Forward, D.y = r * Math.abs((t.bottom - h.height - l) / h.height)), !g && a >= t.right - h.width ? (f.x = T.Forward, D.x = r * Math.abs((t.right - h.width - a) / h.width)) : !u && s <= t.left + h.width && (f.x = T.Backward, D.x = r * Math.abs((t.left + h.width - s) / h.width)), {
    direction: f,
    speed: D
  };
}
function Jn(e) {
  if (e === document.scrollingElement) {
    const {
      innerWidth: o,
      innerHeight: s
    } = window;
    return {
      top: 0,
      left: 0,
      right: o,
      bottom: s,
      width: o,
      height: s
    };
  }
  const {
    top: t,
    left: n,
    right: r,
    bottom: i
  } = e.getBoundingClientRect();
  return {
    top: t,
    left: n,
    right: r,
    bottom: i,
    width: e.clientWidth,
    height: e.clientHeight
  };
}
function Qt(e) {
  return e.reduce((t, n) => he(t, rt(n)), _);
}
function qn(e) {
  return e.reduce((t, n) => t + Jt(n), 0);
}
function Vn(e) {
  return e.reduce((t, n) => t + qt(n), 0);
}
function Zt(e, t) {
  if (t === void 0 && (t = Ne), !e)
    return;
  const {
    top: n,
    left: r,
    bottom: i,
    right: o
  } = t(e);
  Ht(e) && (i <= 0 || o <= 0 || n >= window.innerHeight || r >= window.innerWidth) && e.scrollIntoView({
    block: "center",
    inline: "center"
  });
}
const Gn = [["x", ["left", "right"], qn], ["y", ["top", "bottom"], Vn]];
class ft {
  constructor(t, n) {
    this.rect = void 0, this.width = void 0, this.height = void 0, this.top = void 0, this.bottom = void 0, this.right = void 0, this.left = void 0;
    const r = dt(n), i = Qt(r);
    this.rect = {
      ...t
    }, this.width = t.width, this.height = t.height;
    for (const [o, s, a] of Gn)
      for (const l of s)
        Object.defineProperty(this, l, {
          get: () => {
            const c = a(r), d = i[o] - c;
            return this.rect[l] + d;
          },
          enumerable: !0
        });
    Object.defineProperty(this, "rect", {
      enumerable: !1
    });
  }
}
class xe {
  constructor(t) {
    this.target = void 0, this.listeners = [], this.removeAll = () => {
      this.listeners.forEach((n) => {
        var r;
        return (r = this.target) == null ? void 0 : r.removeEventListener(...n);
      });
    }, this.target = t;
  }
  add(t, n, r) {
    var i;
    (i = this.target) == null || i.addEventListener(t, n, r), this.listeners.push([t, n, r]);
  }
}
function Qn(e) {
  const {
    EventTarget: t
  } = J(e);
  return e instanceof t ? e : ge(e);
}
function Ze(e, t) {
  const n = Math.abs(e.x), r = Math.abs(e.y);
  return typeof t == "number" ? Math.sqrt(n ** 2 + r ** 2) > t : "x" in t && "y" in t ? n > t.x && r > t.y : "x" in t ? n > t.x : "y" in t ? r > t.y : !1;
}
var $;
(function(e) {
  e.Click = "click", e.DragStart = "dragstart", e.Keydown = "keydown", e.ContextMenu = "contextmenu", e.Resize = "resize", e.SelectionChange = "selectionchange", e.VisibilityChange = "visibilitychange";
})($ || ($ = {}));
function It(e) {
  e.preventDefault();
}
function Zn(e) {
  e.stopPropagation();
}
var x;
(function(e) {
  e.Space = "Space", e.Down = "ArrowDown", e.Right = "ArrowRight", e.Left = "ArrowLeft", e.Up = "ArrowUp", e.Esc = "Escape", e.Enter = "Enter";
})(x || (x = {}));
const en = {
  start: [x.Space, x.Enter],
  cancel: [x.Esc],
  end: [x.Space, x.Enter]
}, er = (e, t) => {
  let {
    currentCoordinates: n
  } = t;
  switch (e.code) {
    case x.Right:
      return {
        ...n,
        x: n.x + 25
      };
    case x.Left:
      return {
        ...n,
        x: n.x - 25
      };
    case x.Down:
      return {
        ...n,
        y: n.y + 25
      };
    case x.Up:
      return {
        ...n,
        y: n.y - 25
      };
  }
};
class tn {
  constructor(t) {
    this.props = void 0, this.autoScrollEnabled = !1, this.referenceCoordinates = void 0, this.listeners = void 0, this.windowListeners = void 0, this.props = t;
    const {
      event: {
        target: n
      }
    } = t;
    this.props = t, this.listeners = new xe(ge(n)), this.windowListeners = new xe(J(n)), this.handleKeyDown = this.handleKeyDown.bind(this), this.handleCancel = this.handleCancel.bind(this), this.attach();
  }
  attach() {
    this.handleStart(), this.windowListeners.add($.Resize, this.handleCancel), this.windowListeners.add($.VisibilityChange, this.handleCancel), setTimeout(() => this.listeners.add($.Keydown, this.handleKeyDown));
  }
  handleStart() {
    const {
      activeNode: t,
      onStart: n
    } = this.props, r = t.node.current;
    r && Zt(r), n(_);
  }
  handleKeyDown(t) {
    if (lt(t)) {
      const {
        active: n,
        context: r,
        options: i
      } = this.props, {
        keyboardCodes: o = en,
        coordinateGetter: s = er,
        scrollBehavior: a = "smooth"
      } = i, {
        code: l
      } = t;
      if (o.end.includes(l)) {
        this.handleEnd(t);
        return;
      }
      if (o.cancel.includes(l)) {
        this.handleCancel(t);
        return;
      }
      const {
        collisionRect: c
      } = r.current, d = c ? {
        x: c.left,
        y: c.top
      } : _;
      this.referenceCoordinates || (this.referenceCoordinates = d);
      const u = s(t, {
        active: n,
        context: r.current,
        currentCoordinates: d
      });
      if (u) {
        const g = Ke(u, d), f = {
          x: 0,
          y: 0
        }, {
          scrollableAncestors: D
        } = r.current;
        for (const h of D) {
          const v = t.code, {
            isTop: b,
            isRight: w,
            isLeft: y,
            isBottom: M,
            maxScroll: C,
            minScroll: S
          } = Gt(h), p = Jn(h), m = {
            x: Math.min(v === x.Right ? p.right - p.width / 2 : p.right, Math.max(v === x.Right ? p.left : p.left + p.width / 2, u.x)),
            y: Math.min(v === x.Down ? p.bottom - p.height / 2 : p.bottom, Math.max(v === x.Down ? p.top : p.top + p.height / 2, u.y))
          }, R = v === x.Right && !w || v === x.Left && !y, k = v === x.Down && !M || v === x.Up && !b;
          if (R && m.x !== u.x) {
            const E = h.scrollLeft + g.x, q = v === x.Right && E <= C.x || v === x.Left && E >= S.x;
            if (q && !g.y) {
              h.scrollTo({
                left: E,
                behavior: a
              });
              return;
            }
            q ? f.x = h.scrollLeft - E : f.x = v === x.Right ? h.scrollLeft - C.x : h.scrollLeft - S.x, f.x && h.scrollBy({
              left: -f.x,
              behavior: a
            });
            break;
          } else if (k && m.y !== u.y) {
            const E = h.scrollTop + g.y, q = v === x.Down && E <= C.y || v === x.Up && E >= S.y;
            if (q && !g.x) {
              h.scrollTo({
                top: E,
                behavior: a
              });
              return;
            }
            q ? f.y = h.scrollTop - E : f.y = v === x.Down ? h.scrollTop - C.y : h.scrollTop - S.y, f.y && h.scrollBy({
              top: -f.y,
              behavior: a
            });
            break;
          }
        }
        this.handleMove(t, he(Ke(u, this.referenceCoordinates), f));
      }
    }
  }
  handleMove(t, n) {
    const {
      onMove: r
    } = this.props;
    t.preventDefault(), r(n);
  }
  handleEnd(t) {
    const {
      onEnd: n
    } = this.props;
    t.preventDefault(), this.detach(), n();
  }
  handleCancel(t) {
    const {
      onCancel: n
    } = this.props;
    t.preventDefault(), this.detach(), n();
  }
  detach() {
    this.listeners.removeAll(), this.windowListeners.removeAll();
  }
}
tn.activators = [{
  eventName: "onKeyDown",
  handler: (e, t, n) => {
    let {
      keyboardCodes: r = en,
      onActivation: i
    } = t, {
      active: o
    } = n;
    const {
      code: s
    } = e.nativeEvent;
    if (r.start.includes(s)) {
      const a = o.activatorNode.current;
      return a && e.target !== a ? !1 : (e.preventDefault(), i == null || i({
        event: e.nativeEvent
      }), !0);
    }
    return !1;
  }
}];
function zt(e) {
  return !!(e && "distance" in e);
}
function Pt(e) {
  return !!(e && "delay" in e);
}
class ht {
  constructor(t, n, r) {
    var i;
    r === void 0 && (r = Qn(t.event.target)), this.props = void 0, this.events = void 0, this.autoScrollEnabled = !0, this.document = void 0, this.activated = !1, this.initialCoordinates = void 0, this.timeoutId = null, this.listeners = void 0, this.documentListeners = void 0, this.windowListeners = void 0, this.props = t, this.events = n;
    const {
      event: o
    } = t, {
      target: s
    } = o;
    this.props = t, this.events = n, this.document = ge(s), this.documentListeners = new xe(this.document), this.listeners = new xe(r), this.windowListeners = new xe(J(s)), this.initialCoordinates = (i = Fe(o)) != null ? i : _, this.handleStart = this.handleStart.bind(this), this.handleMove = this.handleMove.bind(this), this.handleEnd = this.handleEnd.bind(this), this.handleCancel = this.handleCancel.bind(this), this.handleKeydown = this.handleKeydown.bind(this), this.removeTextSelection = this.removeTextSelection.bind(this), this.attach();
  }
  attach() {
    const {
      events: t,
      props: {
        options: {
          activationConstraint: n,
          bypassActivationConstraint: r
        }
      }
    } = this;
    if (this.listeners.add(t.move.name, this.handleMove, {
      passive: !1
    }), this.listeners.add(t.end.name, this.handleEnd), this.windowListeners.add($.Resize, this.handleCancel), this.windowListeners.add($.DragStart, It), this.windowListeners.add($.VisibilityChange, this.handleCancel), this.windowListeners.add($.ContextMenu, It), this.documentListeners.add($.Keydown, this.handleKeydown), n) {
      if (r != null && r({
        event: this.props.event,
        activeNode: this.props.activeNode,
        options: this.props.options
      }))
        return this.handleStart();
      if (Pt(n)) {
        this.timeoutId = setTimeout(this.handleStart, n.delay);
        return;
      }
      if (zt(n))
        return;
    }
    this.handleStart();
  }
  detach() {
    this.listeners.removeAll(), this.windowListeners.removeAll(), setTimeout(this.documentListeners.removeAll, 50), this.timeoutId !== null && (clearTimeout(this.timeoutId), this.timeoutId = null);
  }
  handleStart() {
    const {
      initialCoordinates: t
    } = this, {
      onStart: n
    } = this.props;
    t && (this.activated = !0, this.documentListeners.add($.Click, Zn, {
      capture: !0
    }), this.removeTextSelection(), this.documentListeners.add($.SelectionChange, this.removeTextSelection), n(t));
  }
  handleMove(t) {
    var n;
    const {
      activated: r,
      initialCoordinates: i,
      props: o
    } = this, {
      onMove: s,
      options: {
        activationConstraint: a
      }
    } = o;
    if (!i)
      return;
    const l = (n = Fe(t)) != null ? n : _, c = Ke(i, l);
    if (!r && a) {
      if (zt(a)) {
        if (a.tolerance != null && Ze(c, a.tolerance))
          return this.handleCancel();
        if (Ze(c, a.distance))
          return this.handleStart();
      }
      return Pt(a) && Ze(c, a.tolerance) ? this.handleCancel() : void 0;
    }
    t.cancelable && t.preventDefault(), s(l);
  }
  handleEnd() {
    const {
      onEnd: t
    } = this.props;
    this.detach(), t();
  }
  handleCancel() {
    const {
      onCancel: t
    } = this.props;
    this.detach(), t();
  }
  handleKeydown(t) {
    t.code === x.Esc && this.handleCancel();
  }
  removeTextSelection() {
    var t;
    (t = this.document.getSelection()) == null || t.removeAllRanges();
  }
}
const tr = {
  move: {
    name: "pointermove"
  },
  end: {
    name: "pointerup"
  }
};
class nn extends ht {
  constructor(t) {
    const {
      event: n
    } = t, r = ge(n.target);
    super(t, tr, r);
  }
}
nn.activators = [{
  eventName: "onPointerDown",
  handler: (e, t) => {
    let {
      nativeEvent: n
    } = e, {
      onActivation: r
    } = t;
    return !n.isPrimary || n.button !== 0 ? !1 : (r == null || r({
      event: n
    }), !0);
  }
}];
const nr = {
  move: {
    name: "mousemove"
  },
  end: {
    name: "mouseup"
  }
};
var ot;
(function(e) {
  e[e.RightClick = 2] = "RightClick";
})(ot || (ot = {}));
class rr extends ht {
  constructor(t) {
    super(t, nr, ge(t.event.target));
  }
}
rr.activators = [{
  eventName: "onMouseDown",
  handler: (e, t) => {
    let {
      nativeEvent: n
    } = e, {
      onActivation: r
    } = t;
    return n.button === ot.RightClick ? !1 : (r == null || r({
      event: n
    }), !0);
  }
}];
const et = {
  move: {
    name: "touchmove"
  },
  end: {
    name: "touchend"
  }
};
class or extends ht {
  constructor(t) {
    super(t, et);
  }
  static setup() {
    return window.addEventListener(et.move.name, t, {
      capture: !1,
      passive: !1
    }), function() {
      window.removeEventListener(et.move.name, t);
    };
    function t() {
    }
  }
}
or.activators = [{
  eventName: "onTouchStart",
  handler: (e, t) => {
    let {
      nativeEvent: n
    } = e, {
      onActivation: r
    } = t;
    const {
      touches: i
    } = n;
    return i.length > 1 ? !1 : (r == null || r({
      event: n
    }), !0);
  }
}];
var Ce;
(function(e) {
  e[e.Pointer = 0] = "Pointer", e[e.DraggableRect = 1] = "DraggableRect";
})(Ce || (Ce = {}));
var We;
(function(e) {
  e[e.TreeOrder = 0] = "TreeOrder", e[e.ReversedTreeOrder = 1] = "ReversedTreeOrder";
})(We || (We = {}));
function ir(e) {
  let {
    acceleration: t,
    activator: n = Ce.Pointer,
    canScroll: r,
    draggingRect: i,
    enabled: o,
    interval: s = 5,
    order: a = We.TreeOrder,
    pointerCoordinates: l,
    scrollableAncestors: c,
    scrollableAncestorRects: d,
    delta: u,
    threshold: g
  } = e;
  const f = ar({
    delta: u,
    disabled: !o
  }), [D, h] = Dn(), v = z({
    x: 0,
    y: 0
  }), b = z({
    x: 0,
    y: 0
  }), w = L(() => {
    switch (n) {
      case Ce.Pointer:
        return l ? {
          top: l.y,
          bottom: l.y,
          left: l.x,
          right: l.x
        } : null;
      case Ce.DraggableRect:
        return i;
    }
  }, [n, i, l]), y = z(null), M = U(() => {
    const S = y.current;
    if (!S)
      return;
    const p = v.current.x * b.current.x, m = v.current.y * b.current.y;
    S.scrollBy(p, m);
  }, []), C = L(() => a === We.TreeOrder ? [...c].reverse() : c, [a, c]);
  N(
    () => {
      if (!o || !c.length || !w) {
        h();
        return;
      }
      for (const S of C) {
        if ((r == null ? void 0 : r(S)) === !1)
          continue;
        const p = c.indexOf(S), m = d[p];
        if (!m)
          continue;
        const {
          direction: R,
          speed: k
        } = Hn(S, m, w, t, g);
        for (const E of ["x", "y"])
          f[E][R[E]] || (k[E] = 0, R[E] = 0);
        if (k.x > 0 || k.y > 0) {
          h(), y.current = S, D(M, s), v.current = k, b.current = R;
          return;
        }
      }
      v.current = {
        x: 0,
        y: 0
      }, b.current = {
        x: 0,
        y: 0
      }, h();
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [
      t,
      M,
      r,
      h,
      o,
      s,
      // eslint-disable-next-line react-hooks/exhaustive-deps
      JSON.stringify(w),
      // eslint-disable-next-line react-hooks/exhaustive-deps
      JSON.stringify(f),
      D,
      c,
      C,
      d,
      // eslint-disable-next-line react-hooks/exhaustive-deps
      JSON.stringify(g)
    ]
  );
}
const sr = {
  x: {
    [T.Backward]: !1,
    [T.Forward]: !1
  },
  y: {
    [T.Backward]: !1,
    [T.Forward]: !1
  }
};
function ar(e) {
  let {
    delta: t,
    disabled: n
  } = e;
  const r = $e(t);
  return Ae((i) => {
    if (n || !r || !i)
      return sr;
    const o = {
      x: Math.sign(t.x - r.x),
      y: Math.sign(t.y - r.y)
    };
    return {
      x: {
        [T.Backward]: i.x[T.Backward] || o.x === -1,
        [T.Forward]: i.x[T.Forward] || o.x === 1
      },
      y: {
        [T.Backward]: i.y[T.Backward] || o.y === -1,
        [T.Forward]: i.y[T.Forward] || o.y === 1
      }
    };
  }, [n, t, r]);
}
function lr(e, t) {
  const n = t !== null ? e.get(t) : void 0, r = n ? n.node.current : null;
  return Ae((i) => {
    var o;
    return t === null ? null : (o = r ?? i) != null ? o : null;
  }, [r, t]);
}
function cr(e, t) {
  return L(() => e.reduce((n, r) => {
    const {
      sensor: i
    } = r, o = i.activators.map((s) => ({
      eventName: s.eventName,
      handler: t(s.handler, r)
    }));
    return [...n, ...o];
  }, []), [e, t]);
}
var Ee;
(function(e) {
  e[e.Always = 0] = "Always", e[e.BeforeDragging = 1] = "BeforeDragging", e[e.WhileDragging = 2] = "WhileDragging";
})(Ee || (Ee = {}));
var it;
(function(e) {
  e.Optimized = "optimized";
})(it || (it = {}));
const Bt = /* @__PURE__ */ new Map();
function ur(e, t) {
  let {
    dragging: n,
    dependencies: r,
    config: i
  } = t;
  const [o, s] = Y(null), {
    frequency: a,
    measure: l,
    strategy: c
  } = i, d = z(e), u = v(), g = Re(u), f = U(function(b) {
    b === void 0 && (b = []), !g.current && s((w) => w === null ? b : w.concat(b.filter((y) => !w.includes(y))));
  }, [g]), D = z(null), h = Ae((b) => {
    if (u && !n)
      return Bt;
    if (!b || b === Bt || d.current !== e || o != null) {
      const w = /* @__PURE__ */ new Map();
      for (let y of e) {
        if (!y)
          continue;
        if (o && o.length > 0 && !o.includes(y.id) && y.rect.current) {
          w.set(y.id, y.rect.current);
          continue;
        }
        const M = y.node.current, C = M ? new ft(l(M), M) : null;
        y.rect.current = C, C && w.set(y.id, C);
      }
      return w;
    }
    return b;
  }, [e, o, n, u, l]);
  return N(() => {
    d.current = e;
  }, [e]), N(
    () => {
      u || f();
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [n, u]
  ), N(
    () => {
      o && o.length > 0 && s(null);
    },
    //eslint-disable-next-line react-hooks/exhaustive-deps
    [JSON.stringify(o)]
  ), N(
    () => {
      u || typeof a != "number" || D.current !== null || (D.current = setTimeout(() => {
        f(), D.current = null;
      }, a));
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [a, u, f, ...r]
  ), {
    droppableRects: h,
    measureDroppableContainers: f,
    measuringScheduled: o != null
  };
  function v() {
    switch (c) {
      case Ee.Always:
        return !1;
      case Ee.BeforeDragging:
        return n;
      default:
        return !n;
    }
  }
}
function gt(e, t) {
  return Ae((n) => e ? n || (typeof t == "function" ? t(e) : e) : null, [t, e]);
}
function dr(e, t) {
  return gt(e, t);
}
function fr(e) {
  let {
    callback: t,
    disabled: n
  } = e;
  const r = ct(t), i = L(() => {
    if (n || typeof window > "u" || typeof window.MutationObserver > "u")
      return;
    const {
      MutationObserver: o
    } = window;
    return new o(r);
  }, [r, n]);
  return N(() => () => i == null ? void 0 : i.disconnect(), [i]), i;
}
function _e(e) {
  let {
    callback: t,
    disabled: n
  } = e;
  const r = ct(t), i = L(
    () => {
      if (n || typeof window > "u" || typeof window.ResizeObserver > "u")
        return;
      const {
        ResizeObserver: o
      } = window;
      return new o(r);
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [n]
  );
  return N(() => () => i == null ? void 0 : i.disconnect(), [i]), i;
}
function hr(e) {
  return new ft(Ne(e), e);
}
function Ft(e, t, n) {
  t === void 0 && (t = hr);
  const [r, i] = st(a, null), o = fr({
    callback(l) {
      if (e)
        for (const c of l) {
          const {
            type: d,
            target: u
          } = c;
          if (d === "childList" && u instanceof HTMLElement && u.contains(e)) {
            i();
            break;
          }
        }
    }
  }), s = _e({
    callback: i
  });
  return re(() => {
    i(), e ? (s == null || s.observe(e), o == null || o.observe(document.body, {
      childList: !0,
      subtree: !0
    })) : (s == null || s.disconnect(), o == null || o.disconnect());
  }, [e]), r;
  function a(l) {
    if (!e)
      return null;
    if (e.isConnected === !1) {
      var c;
      return (c = l ?? n) != null ? c : null;
    }
    const d = t(e);
    return JSON.stringify(l) === JSON.stringify(d) ? l : d;
  }
}
function gr(e) {
  const t = gt(e);
  return Ut(e, t);
}
const $t = [];
function vr(e) {
  const t = z(e), n = Ae((r) => e ? r && r !== $t && e && t.current && e.parentNode === t.current.parentNode ? r : dt(e) : $t, [e]);
  return N(() => {
    t.current = e;
  }, [e]), n;
}
function pr(e) {
  const [t, n] = Y(null), r = z(e), i = U((o) => {
    const s = Qe(o.target);
    s && n((a) => a ? (a.set(s, rt(s)), new Map(a)) : null);
  }, []);
  return N(() => {
    const o = r.current;
    if (e !== o) {
      s(o);
      const a = e.map((l) => {
        const c = Qe(l);
        return c ? (c.addEventListener("scroll", i, {
          passive: !0
        }), [c, rt(c)]) : null;
      }).filter((l) => l != null);
      n(a.length ? new Map(a) : null), r.current = e;
    }
    return () => {
      s(e), s(o);
    };
    function s(a) {
      a.forEach((l) => {
        const c = Qe(l);
        c == null || c.removeEventListener("scroll", i);
      });
    }
  }, [i, e]), L(() => e.length ? t ? Array.from(t.values()).reduce((o, s) => he(o, s), _) : Qt(e) : _, [e, t]);
}
function Kt(e, t) {
  t === void 0 && (t = []);
  const n = z(null);
  return N(
    () => {
      n.current = null;
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    t
  ), N(() => {
    const r = e !== _;
    r && !n.current && (n.current = e), !r && n.current && (n.current = null);
  }, [e]), n.current ? Ke(e, n.current) : _;
}
function br(e) {
  N(
    () => {
      if (!at)
        return;
      const t = e.map((n) => {
        let {
          sensor: r
        } = n;
        return r.setup == null ? void 0 : r.setup();
      });
      return () => {
        for (const n of t)
          n == null || n();
      };
    },
    // TO-DO: Sensors length could theoretically change which would not be a valid dependency
    // eslint-disable-next-line react-hooks/exhaustive-deps
    e.map((t) => {
      let {
        sensor: n
      } = t;
      return n;
    })
  );
}
function yr(e, t) {
  return L(() => e.reduce((n, r) => {
    let {
      eventName: i,
      handler: o
    } = r;
    return n[i] = (s) => {
      o(s, t);
    }, n;
  }, {}), [e, t]);
}
function rn(e) {
  return L(() => e ? Wn(e) : null, [e]);
}
const tt = [];
function mr(e, t) {
  t === void 0 && (t = Ne);
  const [n] = e, r = rn(n ? J(n) : null), [i, o] = st(a, tt), s = _e({
    callback: o
  });
  return e.length > 0 && i === tt && o(), re(() => {
    e.length ? e.forEach((l) => s == null ? void 0 : s.observe(l)) : (s == null || s.disconnect(), o());
  }, [e]), i;
  function a() {
    return e.length ? e.map((l) => Vt(l) ? r : new ft(t(l), l)) : tt;
  }
}
function on(e) {
  if (!e)
    return null;
  if (e.children.length > 1)
    return e;
  const t = e.children[0];
  return Ue(t) ? t : e;
}
function wr(e) {
  let {
    measure: t
  } = e;
  const [n, r] = Y(null), i = U((c) => {
    for (const {
      target: d
    } of c)
      if (Ue(d)) {
        r((u) => {
          const g = t(d);
          return u ? {
            ...u,
            width: g.width,
            height: g.height
          } : g;
        });
        break;
      }
  }, [t]), o = _e({
    callback: i
  }), s = U((c) => {
    const d = on(c);
    o == null || o.disconnect(), d && (o == null || o.observe(d)), r(d ? t(d) : null);
  }, [t, o]), [a, l] = Xe(s);
  return L(() => ({
    nodeRef: a,
    rect: n,
    setRef: l
  }), [n, a, l]);
}
const Dr = [{
  sensor: nn,
  options: {}
}, {
  sensor: tn,
  options: {}
}], xr = {
  current: {}
}, Be = {
  draggable: {
    measure: kt
  },
  droppable: {
    measure: kt,
    strategy: Ee.WhileDragging,
    frequency: it.Optimized
  },
  dragOverlay: {
    measure: Ne
  }
};
class Se extends Map {
  get(t) {
    var n;
    return t != null && (n = super.get(t)) != null ? n : void 0;
  }
  toArray() {
    return Array.from(this.values());
  }
  getEnabled() {
    return this.toArray().filter((t) => {
      let {
        disabled: n
      } = t;
      return !n;
    });
  }
  getNodeFor(t) {
    var n, r;
    return (n = (r = this.get(t)) == null ? void 0 : r.node.current) != null ? n : void 0;
  }
}
const Cr = {
  activatorEvent: null,
  active: null,
  activeNode: null,
  activeNodeRect: null,
  collisions: null,
  containerNodeRect: null,
  draggableNodes: /* @__PURE__ */ new Map(),
  droppableRects: /* @__PURE__ */ new Map(),
  droppableContainers: /* @__PURE__ */ new Se(),
  over: null,
  dragOverlay: {
    nodeRef: {
      current: null
    },
    rect: null,
    setRef: je
  },
  scrollableAncestors: [],
  scrollableAncestorRects: [],
  measuringConfiguration: Be,
  measureDroppableContainers: je,
  windowRect: null,
  measuringScheduled: !1
}, sn = {
  activatorEvent: null,
  activators: [],
  active: null,
  activeNodeRect: null,
  ariaDescribedById: {
    draggable: ""
  },
  dispatch: je,
  draggableNodes: /* @__PURE__ */ new Map(),
  over: null,
  measureDroppableContainers: je
}, Me = /* @__PURE__ */ Oe(sn), an = /* @__PURE__ */ Oe(Cr);
function Sr() {
  return {
    draggable: {
      active: null,
      initialCoordinates: {
        x: 0,
        y: 0
      },
      nodes: /* @__PURE__ */ new Map(),
      translate: {
        x: 0,
        y: 0
      }
    },
    droppable: {
      containers: new Se()
    }
  };
}
function Rr(e, t) {
  switch (t.type) {
    case O.DragStart:
      return {
        ...e,
        draggable: {
          ...e.draggable,
          initialCoordinates: t.initialCoordinates,
          active: t.active
        }
      };
    case O.DragMove:
      return e.draggable.active ? {
        ...e,
        draggable: {
          ...e.draggable,
          translate: {
            x: t.coordinates.x - e.draggable.initialCoordinates.x,
            y: t.coordinates.y - e.draggable.initialCoordinates.y
          }
        }
      } : e;
    case O.DragEnd:
    case O.DragCancel:
      return {
        ...e,
        draggable: {
          ...e.draggable,
          active: null,
          initialCoordinates: {
            x: 0,
            y: 0
          },
          translate: {
            x: 0,
            y: 0
          }
        }
      };
    case O.RegisterDroppable: {
      const {
        element: n
      } = t, {
        id: r
      } = n, i = new Se(e.droppable.containers);
      return i.set(r, n), {
        ...e,
        droppable: {
          ...e.droppable,
          containers: i
        }
      };
    }
    case O.SetDroppableDisabled: {
      const {
        id: n,
        key: r,
        disabled: i
      } = t, o = e.droppable.containers.get(n);
      if (!o || r !== o.key)
        return e;
      const s = new Se(e.droppable.containers);
      return s.set(n, {
        ...o,
        disabled: i
      }), {
        ...e,
        droppable: {
          ...e.droppable,
          containers: s
        }
      };
    }
    case O.UnregisterDroppable: {
      const {
        id: n,
        key: r
      } = t, i = e.droppable.containers.get(n);
      if (!i || r !== i.key)
        return e;
      const o = new Se(e.droppable.containers);
      return o.delete(n), {
        ...e,
        droppable: {
          ...e.droppable,
          containers: o
        }
      };
    }
    default:
      return e;
  }
}
function Er(e) {
  let {
    disabled: t
  } = e;
  const {
    active: n,
    activatorEvent: r,
    draggableNodes: i
  } = ae(Me), o = $e(r), s = $e(n == null ? void 0 : n.id);
  return N(() => {
    if (!t && !r && o && s != null) {
      if (!lt(o) || document.activeElement === o.target)
        return;
      const a = i.get(s);
      if (!a)
        return;
      const {
        activatorNode: l,
        node: c
      } = a;
      if (!l.current && !c.current)
        return;
      requestAnimationFrame(() => {
        for (const d of [l.current, c.current]) {
          if (!d)
            continue;
          const u = xn(d);
          if (u) {
            u.focus();
            break;
          }
        }
      });
    }
  }, [r, t, i, s, o]), null;
}
function ln(e, t) {
  let {
    transform: n,
    ...r
  } = t;
  return e != null && e.length ? e.reduce((i, o) => o({
    transform: i,
    ...r
  }), n) : n;
}
function Or(e) {
  return L(
    () => ({
      draggable: {
        ...Be.draggable,
        ...e == null ? void 0 : e.draggable
      },
      droppable: {
        ...Be.droppable,
        ...e == null ? void 0 : e.droppable
      },
      dragOverlay: {
        ...Be.dragOverlay,
        ...e == null ? void 0 : e.dragOverlay
      }
    }),
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [e == null ? void 0 : e.draggable, e == null ? void 0 : e.droppable, e == null ? void 0 : e.dragOverlay]
  );
}
function Ar(e) {
  let {
    activeNode: t,
    measure: n,
    initialRect: r,
    config: i = !0
  } = e;
  const o = z(!1), {
    x: s,
    y: a
  } = typeof i == "boolean" ? {
    x: i,
    y: i
  } : i;
  re(() => {
    if (!s && !a || !t) {
      o.current = !1;
      return;
    }
    if (o.current || !r)
      return;
    const c = t == null ? void 0 : t.node.current;
    if (!c || c.isConnected === !1)
      return;
    const d = n(c), u = Ut(d, r);
    if (s || (u.x = 0), a || (u.y = 0), o.current = !0, Math.abs(u.x) > 0 || Math.abs(u.y) > 0) {
      const g = Ht(c);
      g && g.scrollBy({
        top: u.y,
        left: u.x
      });
    }
  }, [t, s, a, r, n]);
}
const He = /* @__PURE__ */ Oe({
  ..._,
  scaleX: 1,
  scaleY: 1
});
var ne;
(function(e) {
  e[e.Uninitialized = 0] = "Uninitialized", e[e.Initializing = 1] = "Initializing", e[e.Initialized = 2] = "Initialized";
})(ne || (ne = {}));
const Vr = /* @__PURE__ */ bn(function(t) {
  var n, r, i, o;
  let {
    id: s,
    accessibility: a,
    autoScroll: l = !0,
    children: c,
    sensors: d = Dr,
    collisionDetection: u = Bn,
    measuring: g,
    modifiers: f,
    ...D
  } = t;
  const h = st(Rr, void 0, Sr), [v, b] = h, [w, y] = Nn(), [M, C] = Y(ne.Uninitialized), S = M === ne.Initialized, {
    draggable: {
      active: p,
      nodes: m,
      translate: R
    },
    droppable: {
      containers: k
    }
  } = v, E = p ? m.get(p) : null, q = z({
    initial: null,
    translated: null
  }), V = L(() => {
    var I;
    return p != null ? {
      id: p,
      // It's possible for the active node to unmount while dragging
      data: (I = E == null ? void 0 : E.data) != null ? I : xr,
      rect: q
    } : null;
  }, [p, E]), Q = z(null), [vt, pt] = Y(null), [G, bt] = Y(null), ve = Re(D, Object.values(D)), Je = Ye("DndDescribedBy", s), yt = L(() => k.getEnabled(), [k]), oe = Or(g), {
    droppableRects: le,
    measureDroppableContainers: Te,
    measuringScheduled: mt
  } = ur(yt, {
    dragging: S,
    dependencies: [R.x, R.y],
    config: oe.droppable
  }), K = lr(m, p), wt = L(() => G ? Fe(G) : null, [G]), Dt = pn(), xt = dr(K, oe.draggable.measure);
  Ar({
    activeNode: p ? m.get(p) : null,
    config: Dt.layoutShiftCompensation,
    initialRect: xt,
    measure: oe.draggable.measure
  });
  const X = Ft(K, oe.draggable.measure, xt), qe = Ft(K ? K.parentElement : null), ie = z({
    activatorEvent: null,
    active: null,
    activeNode: K,
    collisionRect: null,
    collisions: null,
    droppableRects: le,
    draggableNodes: m,
    draggingNode: null,
    draggingNodeRect: null,
    droppableContainers: k,
    over: null,
    scrollableAncestors: [],
    scrollAdjustedTranslate: null
  }), Ct = k.getNodeFor((n = ie.current.over) == null ? void 0 : n.id), se = wr({
    measure: oe.dragOverlay.measure
  }), Le = (r = se.nodeRef.current) != null ? r : K, ce = S ? (i = se.rect) != null ? i : X : null, St = !!(se.nodeRef.current && se.rect), Rt = gr(St ? null : X), Ve = rn(Le ? J(Le) : null), Z = vr(S ? Ct ?? K : null), ke = mr(Z), Ie = ln(f, {
    transform: {
      x: R.x - Rt.x,
      y: R.y - Rt.y,
      scaleX: 1,
      scaleY: 1
    },
    activatorEvent: G,
    active: V,
    activeNodeRect: X,
    containerNodeRect: qe,
    draggingNodeRect: ce,
    over: ie.current.over,
    overlayNodeRect: se.rect,
    scrollableAncestors: Z,
    scrollableAncestorRects: ke,
    windowRect: Ve
  }), Et = wt ? he(wt, R) : null, Ot = pr(Z), cn = Kt(Ot), un = Kt(Ot, [X]), ue = he(Ie, cn), de = ce ? Kn(ce, Ie) : null, pe = V && de ? u({
    active: V,
    collisionRect: de,
    droppableRects: le,
    droppableContainers: yt,
    pointerCoordinates: Et
  }) : null, At = zn(pe, "id"), [ee, Nt] = Y(null), dn = St ? Ie : he(Ie, un), fn = Fn(dn, (o = ee == null ? void 0 : ee.rect) != null ? o : null, X), Mt = U(
    (I, P) => {
      let {
        sensor: B,
        options: te
      } = P;
      if (Q.current == null)
        return;
      const F = m.get(Q.current);
      if (!F)
        return;
      const j = I.nativeEvent, H = new B({
        active: Q.current,
        activeNode: F,
        event: j,
        options: te,
        // Sensors need to be instantiated with refs for arguments that change over time
        // otherwise they are frozen in time with the stale arguments
        context: ie,
        onStart(W) {
          const be = Q.current;
          if (be == null)
            return;
          const ye = m.get(be);
          if (!ye)
            return;
          const {
            onDragStart: ze
          } = ve.current, Pe = {
            active: {
              id: be,
              data: ye.data,
              rect: q
            }
          };
          De(() => {
            ze == null || ze(Pe), C(ne.Initializing), b({
              type: O.DragStart,
              initialCoordinates: W,
              active: be
            }), w({
              type: "onDragStart",
              event: Pe
            });
          });
        },
        onMove(W) {
          b({
            type: O.DragMove,
            coordinates: W
          });
        },
        onEnd: fe(O.DragEnd),
        onCancel: fe(O.DragCancel)
      });
      De(() => {
        pt(H), bt(I.nativeEvent);
      });
      function fe(W) {
        return async function() {
          const {
            active: ye,
            collisions: ze,
            over: Pe,
            scrollAdjustedTranslate: Lt
          } = ie.current;
          let me = null;
          if (ye && Lt) {
            const {
              cancelDrop: we
            } = ve.current;
            me = {
              activatorEvent: j,
              active: ye,
              collisions: ze,
              delta: Lt,
              over: Pe
            }, W === O.DragEnd && typeof we == "function" && await Promise.resolve(we(me)) && (W = O.DragCancel);
          }
          Q.current = null, De(() => {
            b({
              type: W
            }), C(ne.Uninitialized), Nt(null), pt(null), bt(null);
            const we = W === O.DragEnd ? "onDragEnd" : "onDragCancel";
            if (me) {
              const Ge = ve.current[we];
              Ge == null || Ge(me), w({
                type: we,
                event: me
              });
            }
          });
        };
      }
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [m]
  ), hn = U((I, P) => (B, te) => {
    const F = B.nativeEvent, j = m.get(te);
    if (
      // Another sensor is already instantiating
      Q.current !== null || // No active draggable
      !j || // Event has already been captured
      F.dndKit || F.defaultPrevented
    )
      return;
    const H = {
      active: j
    };
    I(B, P.options, H) === !0 && (F.dndKit = {
      capturedBy: P.sensor
    }, Q.current = te, Mt(B, P));
  }, [m, Mt]), Tt = cr(d, hn);
  br(d), re(() => {
    X && M === ne.Initializing && C(ne.Initialized);
  }, [X, M]), N(
    () => {
      const {
        onDragMove: I
      } = ve.current, {
        active: P,
        activatorEvent: B,
        collisions: te,
        over: F
      } = ie.current;
      if (!P || !B)
        return;
      const j = {
        active: P,
        activatorEvent: B,
        collisions: te,
        delta: {
          x: ue.x,
          y: ue.y
        },
        over: F
      };
      De(() => {
        I == null || I(j), w({
          type: "onDragMove",
          event: j
        });
      });
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [ue.x, ue.y]
  ), N(
    () => {
      const {
        active: I,
        activatorEvent: P,
        collisions: B,
        droppableContainers: te,
        scrollAdjustedTranslate: F
      } = ie.current;
      if (!I || Q.current == null || !P || !F)
        return;
      const {
        onDragOver: j
      } = ve.current, H = te.get(At), fe = H && H.rect.current ? {
        id: H.id,
        rect: H.rect.current,
        data: H.data,
        disabled: H.disabled
      } : null, W = {
        active: I,
        activatorEvent: P,
        collisions: B,
        delta: {
          x: F.x,
          y: F.y
        },
        over: fe
      };
      De(() => {
        Nt(fe), j == null || j(W), w({
          type: "onDragOver",
          event: W
        });
      });
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [At]
  ), re(() => {
    ie.current = {
      activatorEvent: G,
      active: V,
      activeNode: K,
      collisionRect: de,
      collisions: pe,
      droppableRects: le,
      draggableNodes: m,
      draggingNode: Le,
      draggingNodeRect: ce,
      droppableContainers: k,
      over: ee,
      scrollableAncestors: Z,
      scrollAdjustedTranslate: ue
    }, q.current = {
      initial: ce,
      translated: de
    };
  }, [V, K, pe, de, m, Le, ce, le, k, ee, Z, ue]), ir({
    ...Dt,
    delta: R,
    draggingRect: de,
    pointerCoordinates: Et,
    scrollableAncestors: Z,
    scrollableAncestorRects: ke
  });
  const gn = L(() => ({
    active: V,
    activeNode: K,
    activeNodeRect: X,
    activatorEvent: G,
    collisions: pe,
    containerNodeRect: qe,
    dragOverlay: se,
    draggableNodes: m,
    droppableContainers: k,
    droppableRects: le,
    over: ee,
    measureDroppableContainers: Te,
    scrollableAncestors: Z,
    scrollableAncestorRects: ke,
    measuringConfiguration: oe,
    measuringScheduled: mt,
    windowRect: Ve
  }), [V, K, X, G, pe, qe, se, m, k, le, ee, Te, Z, ke, oe, mt, Ve]), vn = L(() => ({
    activatorEvent: G,
    activators: Tt,
    active: V,
    activeNodeRect: X,
    ariaDescribedById: {
      draggable: Je
    },
    dispatch: b,
    draggableNodes: m,
    over: ee,
    measureDroppableContainers: Te
  }), [G, Tt, V, X, b, Je, m, ee, Te]);
  return A.createElement(Yt.Provider, {
    value: y
  }, A.createElement(Me.Provider, {
    value: vn
  }, A.createElement(an.Provider, {
    value: gn
  }, A.createElement(He.Provider, {
    value: fn
  }, c)), A.createElement(Er, {
    disabled: (a == null ? void 0 : a.restoreFocus) === !1
  })), A.createElement(Ln, {
    ...a,
    hiddenTextDescribedById: Je
  }));
  function pn() {
    const I = (vt == null ? void 0 : vt.autoScrollEnabled) === !1, P = typeof l == "object" ? l.enabled === !1 : l === !1, B = S && !I && !P;
    return typeof l == "object" ? {
      ...l,
      enabled: B
    } : {
      enabled: B
    };
  }
}), Nr = /* @__PURE__ */ Oe(null), Xt = "button", Mr = "Droppable";
function Gr(e) {
  let {
    id: t,
    data: n,
    disabled: r = !1,
    attributes: i
  } = e;
  const o = Ye(Mr), {
    activators: s,
    activatorEvent: a,
    active: l,
    activeNodeRect: c,
    ariaDescribedById: d,
    draggableNodes: u,
    over: g
  } = ae(Me), {
    role: f = Xt,
    roleDescription: D = "draggable",
    tabIndex: h = 0
  } = i ?? {}, v = (l == null ? void 0 : l.id) === t, b = ae(v ? He : Nr), [w, y] = Xe(), [M, C] = Xe(), S = yr(s, t), p = Re(n);
  re(
    () => (u.set(t, {
      id: t,
      key: o,
      node: w,
      activatorNode: M,
      data: p
    }), () => {
      const R = u.get(t);
      R && R.key === o && u.delete(t);
    }),
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [u, t]
  );
  const m = L(() => ({
    role: f,
    tabIndex: h,
    "aria-disabled": r,
    "aria-pressed": v && f === Xt ? !0 : void 0,
    "aria-roledescription": D,
    "aria-describedby": d.draggable
  }), [r, f, h, v, D, d.draggable]);
  return {
    active: l,
    activatorEvent: a,
    activeNodeRect: c,
    attributes: m,
    isDragging: v,
    listeners: r ? void 0 : S,
    node: w,
    over: g,
    setNodeRef: y,
    setActivatorNodeRef: C,
    transform: b
  };
}
function Tr() {
  return ae(an);
}
const Lr = "Droppable", kr = {
  timeout: 25
};
function Qr(e) {
  let {
    data: t,
    disabled: n = !1,
    id: r,
    resizeObserverConfig: i
  } = e;
  const o = Ye(Lr), {
    active: s,
    dispatch: a,
    over: l,
    measureDroppableContainers: c
  } = ae(Me), d = z({
    disabled: n
  }), u = z(!1), g = z(null), f = z(null), {
    disabled: D,
    updateMeasurementsFor: h,
    timeout: v
  } = {
    ...kr,
    ...i
  }, b = Re(h ?? r), w = U(
    () => {
      if (!u.current) {
        u.current = !0;
        return;
      }
      f.current != null && clearTimeout(f.current), f.current = setTimeout(() => {
        c(Array.isArray(b.current) ? b.current : [b.current]), f.current = null;
      }, v);
    },
    //eslint-disable-next-line react-hooks/exhaustive-deps
    [v]
  ), y = _e({
    callback: w,
    disabled: D || !s
  }), M = U((m, R) => {
    y && (R && (y.unobserve(R), u.current = !1), m && y.observe(m));
  }, [y]), [C, S] = Xe(M), p = Re(t);
  return N(() => {
    !y || !C.current || (y.disconnect(), u.current = !1, y.observe(C.current));
  }, [C, y]), re(
    () => (a({
      type: O.RegisterDroppable,
      element: {
        id: r,
        key: o,
        disabled: n,
        node: C,
        rect: g,
        data: p
      }
    }), () => a({
      type: O.UnregisterDroppable,
      key: o,
      id: r
    })),
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [r]
  ), N(() => {
    n !== d.current.disabled && (a({
      type: O.SetDroppableDisabled,
      id: r,
      key: o,
      disabled: n
    }), d.current.disabled = n);
  }, [r, o, n, a]), {
    active: s,
    rect: g,
    isOver: (l == null ? void 0 : l.id) === r,
    node: C,
    over: l,
    setNodeRef: S
  };
}
function Ir(e) {
  let {
    animation: t,
    children: n
  } = e;
  const [r, i] = Y(null), [o, s] = Y(null), a = $e(n);
  return !n && !r && a && i(a), re(() => {
    if (!o)
      return;
    const l = r == null ? void 0 : r.key, c = r == null ? void 0 : r.props.id;
    if (l == null || c == null) {
      i(null);
      return;
    }
    Promise.resolve(t(c, o)).then(() => {
      i(null);
    });
  }, [t, r, o]), A.createElement(A.Fragment, null, n, r ? yn(r, {
    ref: s
  }) : null);
}
const zr = {
  x: 0,
  y: 0,
  scaleX: 1,
  scaleY: 1
};
function Pr(e) {
  let {
    children: t
  } = e;
  return A.createElement(Me.Provider, {
    value: sn
  }, A.createElement(He.Provider, {
    value: zr
  }, t));
}
const Br = {
  position: "fixed",
  touchAction: "none"
}, Fr = (e) => lt(e) ? "transform 250ms ease" : void 0, $r = /* @__PURE__ */ mn((e, t) => {
  let {
    as: n,
    activatorEvent: r,
    adjustScale: i,
    children: o,
    className: s,
    rect: a,
    style: l,
    transform: c,
    transition: d = Fr
  } = e;
  if (!a)
    return null;
  const u = i ? c : {
    ...c,
    scaleX: 1,
    scaleY: 1
  }, g = {
    ...Br,
    width: a.width,
    height: a.height,
    top: a.top,
    left: a.left,
    transform: nt.Transform.toString(u),
    transformOrigin: i && r ? kn(r, a) : void 0,
    transition: typeof d == "function" ? d(r) : d,
    ...l
  };
  return A.createElement(n, {
    className: s,
    style: g,
    ref: t
  }, o);
}), Kr = (e) => (t) => {
  let {
    active: n,
    dragOverlay: r
  } = t;
  const i = {}, {
    styles: o,
    className: s
  } = e;
  if (o != null && o.active)
    for (const [a, l] of Object.entries(o.active))
      l !== void 0 && (i[a] = n.node.style.getPropertyValue(a), n.node.style.setProperty(a, l));
  if (o != null && o.dragOverlay)
    for (const [a, l] of Object.entries(o.dragOverlay))
      l !== void 0 && r.node.style.setProperty(a, l);
  return s != null && s.active && n.node.classList.add(s.active), s != null && s.dragOverlay && r.node.classList.add(s.dragOverlay), function() {
    for (const [l, c] of Object.entries(i))
      n.node.style.setProperty(l, c);
    s != null && s.active && n.node.classList.remove(s.active);
  };
}, Xr = (e) => {
  let {
    transform: {
      initial: t,
      final: n
    }
  } = e;
  return [{
    transform: nt.Transform.toString(t)
  }, {
    transform: nt.Transform.toString(n)
  }];
}, jr = {
  duration: 250,
  easing: "ease",
  keyframes: Xr,
  sideEffects: /* @__PURE__ */ Kr({
    styles: {
      active: {
        opacity: "0"
      }
    }
  })
};
function Wr(e) {
  let {
    config: t,
    draggableNodes: n,
    droppableContainers: r,
    measuringConfiguration: i
  } = e;
  return ct((o, s) => {
    if (t === null)
      return;
    const a = n.get(o);
    if (!a)
      return;
    const l = a.node.current;
    if (!l)
      return;
    const c = on(s);
    if (!c)
      return;
    const {
      transform: d
    } = J(s).getComputedStyle(s), u = _t(d);
    if (!u)
      return;
    const g = typeof t == "function" ? t : Yr(t);
    return Zt(l, i.draggable.measure), g({
      active: {
        id: o,
        data: a.data,
        node: l,
        rect: i.draggable.measure(l)
      },
      draggableNodes: n,
      dragOverlay: {
        node: s,
        rect: i.dragOverlay.measure(c)
      },
      droppableContainers: r,
      measuringConfiguration: i,
      transform: u
    });
  });
}
function Yr(e) {
  const {
    duration: t,
    easing: n,
    sideEffects: r,
    keyframes: i
  } = {
    ...jr,
    ...e
  };
  return (o) => {
    let {
      active: s,
      dragOverlay: a,
      transform: l,
      ...c
    } = o;
    if (!t)
      return;
    const d = {
      x: a.rect.left - s.rect.left,
      y: a.rect.top - s.rect.top
    }, u = {
      scaleX: l.scaleX !== 1 ? s.rect.width * l.scaleX / a.rect.width : 1,
      scaleY: l.scaleY !== 1 ? s.rect.height * l.scaleY / a.rect.height : 1
    }, g = {
      x: l.x - d.x,
      y: l.y - d.y,
      ...u
    }, f = i({
      ...c,
      active: s,
      dragOverlay: a,
      transform: {
        initial: l,
        final: g
      }
    }), [D] = f, h = f[f.length - 1];
    if (JSON.stringify(D) === JSON.stringify(h))
      return;
    const v = r == null ? void 0 : r({
      active: s,
      dragOverlay: a,
      ...c
    }), b = a.node.animate(f, {
      duration: t,
      easing: n,
      fill: "forwards"
    });
    return new Promise((w) => {
      b.onfinish = () => {
        v == null || v(), w();
      };
    });
  };
}
let jt = 0;
function Ur(e) {
  return L(() => {
    if (e != null)
      return jt++, jt;
  }, [e]);
}
const Zr = /* @__PURE__ */ A.memo((e) => {
  let {
    adjustScale: t = !1,
    children: n,
    dropAnimation: r,
    style: i,
    transition: o,
    modifiers: s,
    wrapperElement: a = "div",
    className: l,
    zIndex: c = 999
  } = e;
  const {
    activatorEvent: d,
    active: u,
    activeNodeRect: g,
    containerNodeRect: f,
    draggableNodes: D,
    droppableContainers: h,
    dragOverlay: v,
    over: b,
    measuringConfiguration: w,
    scrollableAncestors: y,
    scrollableAncestorRects: M,
    windowRect: C
  } = Tr(), S = ae(He), p = Ur(u == null ? void 0 : u.id), m = ln(s, {
    activatorEvent: d,
    active: u,
    activeNodeRect: g,
    containerNodeRect: f,
    draggingNodeRect: v.rect,
    over: b,
    overlayNodeRect: v.rect,
    scrollableAncestors: y,
    scrollableAncestorRects: M,
    transform: S,
    windowRect: C
  }), R = gt(g), k = Wr({
    config: r,
    draggableNodes: D,
    droppableContainers: h,
    measuringConfiguration: w
  }), E = R ? v.setRef : void 0;
  return A.createElement(Pr, null, A.createElement(Ir, {
    animation: k
  }, u && p ? A.createElement($r, {
    key: p,
    id: u.id,
    ref: E,
    as: a,
    activatorEvent: d,
    adjustScale: t,
    className: l,
    transition: o,
    rect: R,
    style: {
      zIndex: c,
      ...i
    },
    transform: m
  }, n) : null));
});
export {
  Ce as AutoScrollActivator,
  Vr as DndContext,
  Zr as DragOverlay,
  x as KeyboardCode,
  tn as KeyboardSensor,
  it as MeasuringFrequency,
  Ee as MeasuringStrategy,
  rr as MouseSensor,
  nn as PointerSensor,
  or as TouchSensor,
  We as TraversalOrder,
  ln as applyModifiers,
  Tn as defaultAnnouncements,
  _ as defaultCoordinates,
  jr as defaultDropAnimation,
  Kr as defaultDropAnimationSideEffects,
  Mn as defaultScreenReaderInstructions,
  Ne as getClientRect,
  zn as getFirstCollision,
  dt as getScrollableAncestors,
  Bn as rectIntersection,
  Tr as useDndContext,
  An as useDndMonitor,
  Gr as useDraggable,
  Qr as useDroppable
};
