import { FC } from 'react';
import './index.less';
interface BitzDatePickerProps {
    /**
     * 选择类型 date-单时间|range-双时间；默认为单时间
     */
    type?: 'date' | 'range';
    /**
     * 选择器类型
     */
    picker?: 'date' | 'week' | 'month' | 'quarter' | 'year';
    /**
     * 选择时间返回的参数
     */
    onChange?: (val: string | [string, string]) => void;
    /**
     * 增加时间选择功能,无论是DatePicker还是RangePicker都适用
     */
    showTime?: any;
    /**
     * 设置日期格式
     */
    format?: string;
    /**
     * 设默认日期
     */
    defaultValue?: any;
    /**
     * 不可选择的日期
     */
    disabledDate?: any;
    /**
     * 不可选择的时分秒
     */
    disabledDateTime?: any;
    /**
     * 禁止时间操作
     */
    disabled?: boolean;
}
declare const BitzDatePicker: FC<BitzDatePickerProps>;
export default BitzDatePicker;
