import { FC, ReactNode } from 'react';
import './index.less';
interface BitzFloatLayoutProps {
    /**
     * 是否可见
     */
    open?: boolean;
    /**
     * 点击遮罩层或左上角叉或取消按钮的回调
     */
    onClose?: () => void;
    /**
     * 是否展示遮罩
     */
    mask?: boolean;
    /**
     * 标题
     */
    title?: string;
    /**
     * 容器外层 className 设置，如果需要设置最外层
     */
    className?: string;
    /**
     * 切换抽屉时动画结束后的回调
     * @param {boolean} open
     */
    afterOpenChange?: (open: boolean) => void;
    /**
     * 设置 z-index
     */
    zIndex?: number;
    children?: ReactNode;
}
declare const BitzFloatLayout: FC<BitzFloatLayoutProps>;
export default BitzFloatLayout;
