import { FC } from 'react';
/** Highlight属性 */
export interface BitzHighlightProps {
    /** 是否启用转义 */
    autoEscape?: boolean;
    /** 是否启用大小写转换 */
    caseSensitive?: boolean;
    /** 文本级别类型 */
    type?: 'primary' | 'secondary';
    /** 源文本 */
    sourceString: string;
    /** 期望被高亮的文本 */
    keywords: string | string[];
    /** 根节点对应的 HTML 标签名 */
    tag?: keyof HTMLElementTagNameMap;
    /** 根节点的类名 */
    tagClass?: string;
    /** 高亮文本元素的 HTML 标签名 */
    highlightTag?: keyof HTMLElementTagNameMap;
    /** 高亮元素的类名 */
    highlightClass?: string;
    /** 非高亮元素对应的 HTML 标签名 */
    unhighlightTag?: keyof HTMLElementTagNameMap;
    /** 非高亮元素的类名 */
    unhighlightClass?: string;
}
/** Highlight Componet */
declare const BitzHighlight: FC<BitzHighlightProps>;
export default BitzHighlight;
