import React, { FC } from 'react';
import './index.less';
/** Tabbar属性 */
export interface BitzTabbarProps {
    /** 当前选中Tabbar.Item的name */
    value: string | number;
    /** 组件层级大小 */
    zIndex?: number;
    /** （未开发）是否开启路由模式，路由模式下Tabbar.Item组件新增to和replace属性 */
    route?: boolean;
    /** 是否固定在底部 */
    fixed?: boolean;
    /** 是否显示border */
    border?: boolean;
    /** 固定在底部时，是否在tab位置生成一个等高的占位元素，生成的元素不能根据placeholder值动态增删 */
    placeholder?: boolean;
    /** 是否添加IOS底部安全距离 */
    safeAreaInsetBottom?: boolean;
    /** value值变化 */
    onChange: (value: string | number) => void;
    /** children为Tabbar.Item组件，建议使用闭合标签 */
    children: React.ReactNode;
}
/** Tabbar Componet */
declare const BitzTabbar: FC<BitzTabbarProps>;
export default BitzTabbar;
