import { FC, MouseEventHandler } from 'react';
import { DensitySize } from '../../Store';
export interface BitzTableToolBarProps {
    size?: DensitySize;
    loading?: boolean;
    /**
     * 导出menu的点击事件，通过key值判断是导出选中数据或导出查询结果
     * @Key1 导出选中数据: selected
     * @Key2 导出查询结果: all
     */
    onExport?: (key: 'selected' | 'all') => void;
    /** 表格刷新 */
    onRefresh?: MouseEventHandler;
    /** 表格布局更改 */
    onSizeChange?: (size: DensitySize) => void;
    /** 列配置更改 */
    onColumnChange?: (columns: any) => void;
    children?: React.ReactNode;
}
/** 表格头部右侧icon按钮组 -- 导出、刷新、布局配置，列配置 */
declare const BitzTableToolBar: FC<BitzTableToolBarProps>;
export default BitzTableToolBar;
