/// <reference types="react" />
import { BitzTableProps } from './Table';
import BitzTableProvider, { TableContext as BitzTableContext, DensitySize as BitzTableSizeType, ProTableColumn } from './Store';
import ActionBar from './ActionBar';
import ToolBar from './ToolBar';
import ActionCol from './ActionCol';
interface BitzTableColumnType<RecordType = any> extends ProTableColumn<RecordType> {
    mobileHide?: boolean;
}
type BitzTableColumnsType<DataType> = BitzTableColumnType<DataType>[];
type CompoundedComponent = React.ForwardRefExoticComponent<BitzTableProps> & {
    ActionBar: typeof ActionBar;
    ToolBar: typeof ToolBar;
    ActionCol: typeof ActionCol;
};
declare const BitzTable: CompoundedComponent;
export type { BitzTableProps, BitzTableSizeType, BitzTableColumnType, BitzTableColumnsType, };
export { BitzTableProvider, BitzTableContext };
export default BitzTable;
