import { Key, ReactNode } from 'react';
import { ColumnsType } from 'antd/es/table';
import { FieldNames, PaginationChangeEvent, PaginationProps, TableSelectPopupParentRender } from '..';
import { BaseOptionType, SelectProps } from 'antd/es/select';
import './index.less';
interface TableSelectPopupProps<T> {
    columns: ColumnsType<T>;
    tableData: T[];
    total: number;
    loading: boolean;
    loadingFailed: boolean;
    loadAgain: () => void;
    page: PaginationProps;
    onPageChange: PaginationChangeEvent;
    /** 表格搜索input元素 */
    searchInput: ReactNode;
    /** 常用标签 */
    showToolTagSelect?: boolean;
    toolTags?: SelectProps['options'];
    onToolTagChange?: SelectProps['onChange'];
    /** 左右布局 */
    lrLayout?: boolean;
    /** 下拉Popup左边区域渲染函数 */
    parentRender?: TableSelectPopupParentRender;
    keys?: Key[];
    rows?: T[];
    /** 回填数据的属性 */
    fieldNames: FieldNames;
    onChange: (value: Key[], options: T[], btnClickMethod?: 'confirm' | 'clear') => void;
    onDropdownVisibleChange: (open: boolean) => void;
}
declare function TableSelectPopup<T extends BaseOptionType>({ columns: columnOption, tableData, total, loading, loadingFailed, loadAgain, page, onPageChange, searchInput, showToolTagSelect, toolTags, onToolTagChange, lrLayout, parentRender, keys, rows, fieldNames, onChange, onDropdownVisibleChange, }: TableSelectPopupProps<T>): import("react/jsx-runtime").JSX.Element;
export default TableSelectPopup;
